Index: /trunk/gui/scripts/flowdial.tcl
===================================================================
--- /trunk/gui/scripts/flowdial.tcl	(revision 1923)
+++ /trunk/gui/scripts/flowdial.tcl	(revision 1924)
@@ -36,5 +36,4 @@
     itk_option define -max max Max ""
     itk_option define -variable variable Variable ""
-    itk_option define -offset offset Offset 1
 
     itk_option define -thickness thickness Thickness 0
@@ -68,5 +67,4 @@
     protected method _fixSize {}
     protected method _fixValue {args}
-    protected method _fixOffsets {}
 
     private method _current {value}
@@ -81,6 +79,4 @@
     private variable _activecolor ""  ;# width allocated for values
     private variable _vwidth 0        ;# width allocated for values
-    private variable _offset_pos 1    ;#
-    private variable _offset_neg -1   ;#
     public variable min 0.0
     public variable max 1.0
@@ -101,20 +97,18 @@
     bind $itk_component(dial) <Configure> [itcl::code $this _redraw]
 
-#    if 0 {
+    if 0 {
     bind $itk_component(dial) <ButtonPress-1> [itcl::code $this _click %x %y]
     bind $itk_component(dial) <B1-Motion> [itcl::code $this _click %x %y]
     bind $itk_component(dial) <ButtonRelease-1> [itcl::code $this _click %x %y]
-    #bind $itk_component(hull) <KeyPress-Left> [itcl::code $this _navigate $_offset_neg]
-    #bind $itk_component(hull) <KeyPress-Right> [itcl::code $this _navigate $_offset_pos]
-
+    bind $itk_component(hull) <KeyPress-Left> [itcl::code $this _navigate -1]
+    bind $itk_component(hull) <KeyPress-Right> [itcl::code $this _navigate 1]
     $itk_component(dial) bind  "knob" <Enter> \
         [list $itk_component(dial) configure -cursor sb_h_double_arrow]
     $itk_component(dial) bind  "knob" <Leave> \
         [list $itk_component(dial) configure -cursor ""]
-#    }
+    }
     eval itk_initialize $args
 
     _fixSize
-    _fixOffsets
 }
 
@@ -137,5 +131,5 @@
 itcl::body Rappture::Flowdial::current {value} {
     if {"" == $value} {
-        return
+        return 
     }
     _current [ms2rel $value]
@@ -154,8 +148,8 @@
     if { $relval < 0.0 } {
         set relval 0.0
-    }
+    } 
     if { $relval > 1.0 } {
         set relval 1.0
-    }
+    }                                        
     set _current $relval
     after cancel [itcl::code $this _redraw]
@@ -334,36 +328,22 @@
 # clients.
 # ----------------------------------------------------------------------
-#itcl::body Rappture::Flowdial::_navigate {offset} {
-#    set index [lsearch -exact $_values $_current]
-#    if {$index >= 0} {
-#        incr index $offset
-#        if {$index >= [llength $_values]} {
-#            set index [expr {[llength $_values]-1}]
-#        } elseif {$index < 0} {
-#            set index 0
-#        }
-#
-#        set newval [lindex $_values $index]
-#        if {$newval != $_current} {
-#            current $newval
-#            _redraw
-#
-#            event generate $itk_component(hull) <<Value>>
-#        }
-#    }
-#}
-
-
-# ----------------------------------------------------------------------
-# USAGE: _navigate <offset>
-#
-# Called automatically whenever the user presses left/right keys
-# to nudge the current value left or right by some <offset>.  If the
-# value actually changes, it generates a <<Value>> event to notify
-# clients.
-# ----------------------------------------------------------------------
 itcl::body Rappture::Flowdial::_navigate {offset} {
-    _current [ms2rel [expr $_current + $offset]]
-    event generate $itk_component(hull) <<Value>>
+    set index [lsearch -exact $_values $_current]
+    if {$index >= 0} {
+        incr index $offset
+        if {$index >= [llength $_values]} {
+            set index [expr {[llength $_values]-1}]
+        } elseif {$index < 0} {
+            set index 0
+        }
+
+        set newval [lindex $_values $index]
+        if {$newval != $_current} {
+            current $newval
+            _redraw
+
+            event generate $itk_component(hull) <<Value>>
+        }
+    }
 }
 
@@ -434,18 +414,4 @@
     upvar #0 $itk_option(-variable) var
     _current [ms2rel $var]
-}
-
-# ----------------------------------------------------------------------
-# USAGE: _fixOffsets
-#
-# ----------------------------------------------------------------------
-itcl::body Rappture::Flowdial::_fixOffsets {} {
-    if {0 == $itk_option(-offset)} {
-        return
-    }
-    set _offset_pos $itk_option(-offset)
-    set _offset_neg [expr -1*$_offset_pos]
-    bind $itk_component(hull) <KeyPress-Left> [itcl::code $this _navigate $_offset_neg]
-    bind $itk_component(hull) <KeyPress-Right> [itcl::code $this _navigate $_offset_pos]
 }
 
@@ -624,12 +590,2 @@
     }
 }
-
-# ----------------------------------------------------------------------
-# CONFIGURE: -offset
-# ----------------------------------------------------------------------
-itcl::configbody Rappture::Flowdial::offset {
-    if {![string is double $itk_option(-offset)]} {
-        error "bad value \"$itk_option(-offset)\": should be >= 0.0"
-    }
-    _fixOffsets
-}