Index: branches/blt4/examples/zoo/parallelepiped/Makefile.in
===================================================================
--- branches/blt4/examples/zoo/parallelepiped/Makefile.in	(revision 1950)
+++ branches/blt4/examples/zoo/parallelepiped/Makefile.in	(revision 1950)
@@ -0,0 +1,38 @@
+
+bindir          = @bindir@
+datadir		= @datadir@
+datarootdir	= @datarootdir@
+exec_prefix     = @exec_prefix@
+includedir      = @includedir@
+libdir          = @libdir@
+mandir          = @mandir@
+srcdir		= @srcdir@
+prefix          = @prefix@
+
+INSTALL		= @INSTALL@
+MKDIR_P		= @MKDIR_P@
+VPATH		= $(srcdir)
+RM		= rm -f
+
+FILES		= \
+		$(srcdir)/cell.tcl \
+		$(srcdir)/tool.xml
+
+destdir		= $(prefix)/examples/zoo/cell
+
+all: 
+	$(MAKE) -C examples all
+
+install: 
+	$(MKDIR_P) -m 0755 $(destdir)
+	for i in $(FILES) ; do \
+	  $(INSTALL) -m 0444  $$i $(destdir) ; \
+	done
+	$(MAKE) -C examples install
+
+clean:
+	$(MAKE) -C examples clean
+
+distclean: 
+	$(MAKE) -C examples distclean
+	$(RM) Makefile *~
Index: branches/blt4/examples/zoo/parallelepiped/cell.tcl
===================================================================
--- branches/blt4/examples/zoo/parallelepiped/cell.tcl	(revision 1950)
+++ branches/blt4/examples/zoo/parallelepiped/cell.tcl	(revision 1950)
@@ -0,0 +1,52 @@
+
+
+package require Rappture
+
+set driver [Rappture::library [lindex $argv 0]]
+
+set components "output.structure.components"
+
+set pdb {
+ATOM      0   Si UNK A   1       0.000   0.000   0.000  1.00
+ATOM      1   Si UNK A   1       2.710   2.710   0.000  1.00
+ATOM      2   Si UNK A   1       2.710   0.000   2.710  1.00
+ATOM      3   Si UNK A   1       0.000   2.710   2.710  1.00
+ATOM      4   Si UNK A   1       5.420   2.710   2.710  1.00
+ATOM      5   Si UNK A   1       2.710   5.420   2.710  1.00
+ATOM      6   Si UNK A   1       2.710   2.710   5.420  1.00
+ATOM      7   Si UNK A   1       5.420   5.420   5.420  1.00
+ATOM      8   Si UNK A   1       1.355   1.355   1.355  1.00
+TER       9      UNK A   1
+}
+
+set cell_vertices {
+    0.0, 0.0, 0.0,
+    2.71, 2.71, 0.0,
+    0.0, 0.0, 0.0,
+    2.71, 0.0, 2.71,
+    0.0, 0.0, 0.0,
+    0.0, 2.71, 2.71,
+    2.71, 2.71, 0.0,
+    5.42, 2.71, 2.71,
+    2.71, 0.0, 2.71,
+    5.42, 2.71, 2.71,
+    2.71, 0.0, 2.71,
+    2.71, 2.71, 5.42,
+    2.71, 2.71, 0.0,
+    2.71, 5.42, 2.71,
+    0.0, 2.71, 2.71,
+    2.71, 5.42, 2.71,
+    5.42, 5.42, 5.42,
+    2.71, 5.42, 2.71,
+    5.42, 2.71, 2.71,
+    5.42, 5.42, 5.42,
+    0.0, 2.71, 2.71,
+    2.71, 2.71, 5.42,
+    5.42, 5.42, 5.42,
+    2.71, 2.71, 5.42
+}
+$driver put -append no $components.molecule.pdb $pdb
+$driver put -append no $components.cell.values $cell_vertices
+
+Rappture::result $driver 
+exit 0
Index: branches/blt4/examples/zoo/parallelepiped/parallelepiped.tcl
===================================================================
--- branches/blt4/examples/zoo/parallelepiped/parallelepiped.tcl	(revision 1950)
+++ branches/blt4/examples/zoo/parallelepiped/parallelepiped.tcl	(revision 1950)
@@ -0,0 +1,33 @@
+
+
+package require Rappture
+
+set driver [Rappture::library [lindex $argv 0]]
+
+set components "output.structure.components"
+
+set pdb {
+ATOM      0   Si UNK A   1       0.000   0.000   0.000  1.00
+ATOM      1   Si UNK A   1       2.710   2.710   0.000  1.00
+ATOM      2   Si UNK A   1       2.710   0.000   2.710  1.00
+ATOM      3   Si UNK A   1       0.000   2.710   2.710  1.00
+ATOM      4   Si UNK A   1       5.420   2.710   2.710  1.00
+ATOM      5   Si UNK A   1       2.710   5.420   2.710  1.00
+ATOM      6   Si UNK A   1       2.710   2.710   5.420  1.00
+ATOM      7   Si UNK A   1       5.420   5.420   5.420  1.00
+ATOM      8   Si UNK A   1       1.355   1.355   1.355  1.00
+TER       9      UNK A   1
+}
+
+$driver put $components.molecule.pdb $pdb
+
+$driver put $components.parallelepiped.origin "0.0 0.0 0.0"
+$driver put $components.parallelpiped.scale "5.42"
+#$driver put $components.parallelpiped.scale "1.0"
+ 
+$driver put $components.parallelpiped.vector(1) ".5 .5 .0"
+$driver put $components.parallelpiped.vector(2) ".5 .0 .5"
+$driver put $components.parallelpiped.vector(3) ".0 .5 .5"
+
+Rappture::result $driver 
+exit 0
Index: branches/blt4/examples/zoo/parallelepiped/run1289944753803000.xml
===================================================================
--- branches/blt4/examples/zoo/parallelepiped/run1289944753803000.xml	(revision 1950)
+++ branches/blt4/examples/zoo/parallelepiped/run1289944753803000.xml	(revision 1950)
@@ -0,0 +1,81 @@
+<?xml version="1.0"?>
+<run>
+    <tool>
+        <about>Press Simulate to view results.</about>
+        <command>tclsh @tool/parallelpiped.tcl @driver</command>
+        <version>
+            <rappture>
+                <revision>$LastChangedRevision: 1719 $</revision>
+                <modified>$LastChangedDate: 2010-05-18 19:26:32 -0400 (Tue, 18 May 2010) $</modified>
+                <language>tcl</language>
+            </rappture>
+        </version>
+    </tool>
+    <input>
+        <number id="temperature">
+            <about>
+                <label>Ambient temperature</label>
+                <description>Temperature of the environment.</description>
+            </about>
+            <units>K</units>
+            <min>0K</min>
+            <max>500K</max>
+            <default>300K</default>
+            <preset>
+                <value>300K</value>
+                <label>300K (room temperature)</label>
+            </preset>
+            <preset>
+                <value>77K</value>
+                <label>77K (liquid nitrogen)</label>
+            </preset>
+            <preset>
+                <value>4.2K</value>
+                <label>4.2K (liquid helium)</label>
+            </preset>
+            <current>300K</current>
+        </number>
+        <number id="Ef">
+            <about>
+                <label>Fermi Level</label>
+                <description>Energy at center of distribution.</description>
+            </about>
+            <units>eV</units>
+            <min>-10eV</min>
+            <max>10eV</max>
+            <default>0eV</default>
+            <current>0eV</current>
+        </number>
+    </input>
+    <output>
+        <structure>
+            <components>
+                <molecule>
+                    <pdb>
+ATOM      0   Si UNK A   1       0.000   0.000   0.000  1.00
+ATOM      1   Si UNK A   1       2.710   2.710   0.000  1.00
+ATOM      2   Si UNK A   1       2.710   0.000   2.710  1.00
+ATOM      3   Si UNK A   1       0.000   2.710   2.710  1.00
+ATOM      4   Si UNK A   1       5.420   2.710   2.710  1.00
+ATOM      5   Si UNK A   1       2.710   5.420   2.710  1.00
+ATOM      6   Si UNK A   1       2.710   2.710   5.420  1.00
+ATOM      7   Si UNK A   1       5.420   5.420   5.420  1.00
+ATOM      8   Si UNK A   1       1.355   1.355   1.355  1.00
+TER       9      UNK A   1
+</pdb>
+                </molecule>
+                <parallelpiped>
+                    <origin>0.0 0.0 0.0</origin>
+                    <scale>5.42</scale>
+                    <vector id="1">.5 .5 .0</vector>
+                    <vector id="2">.5 .0 .5</vector>
+                    <vector id="3">.0 .5 .5</vector>
+                </parallelpiped>
+            </components>
+        </structure>
+        <time>Tue Nov 16 16:59:13 EST 2010</time>
+        <status>ok</status>
+        <user>gah</user>
+    </output>
+</run>
+
Index: branches/blt4/examples/zoo/parallelepiped/run1289944950293000.xml
===================================================================
--- branches/blt4/examples/zoo/parallelepiped/run1289944950293000.xml	(revision 1950)
+++ branches/blt4/examples/zoo/parallelepiped/run1289944950293000.xml	(revision 1950)
@@ -0,0 +1,81 @@
+<?xml version="1.0"?>
+<run>
+    <tool>
+        <about>Press Simulate to view results.</about>
+        <command>tclsh @tool/parallelpiped.tcl @driver</command>
+        <version>
+            <rappture>
+                <revision>$LastChangedRevision: 1719 $</revision>
+                <modified>$LastChangedDate: 2010-05-18 19:26:32 -0400 (Tue, 18 May 2010) $</modified>
+                <language>tcl</language>
+            </rappture>
+        </version>
+    </tool>
+    <input>
+        <number id="temperature">
+            <about>
+                <label>Ambient temperature</label>
+                <description>Temperature of the environment.</description>
+            </about>
+            <units>K</units>
+            <min>0K</min>
+            <max>500K</max>
+            <default>300K</default>
+            <preset>
+                <value>300K</value>
+                <label>300K (room temperature)</label>
+            </preset>
+            <preset>
+                <value>77K</value>
+                <label>77K (liquid nitrogen)</label>
+            </preset>
+            <preset>
+                <value>4.2K</value>
+                <label>4.2K (liquid helium)</label>
+            </preset>
+            <current>300K</current>
+        </number>
+        <number id="Ef">
+            <about>
+                <label>Fermi Level</label>
+                <description>Energy at center of distribution.</description>
+            </about>
+            <units>eV</units>
+            <min>-10eV</min>
+            <max>10eV</max>
+            <default>0eV</default>
+            <current>0eV</current>
+        </number>
+    </input>
+    <output>
+        <structure>
+            <components>
+                <molecule>
+                    <pdb>
+ATOM      0   Si UNK A   1       0.000   0.000   0.000  1.00
+ATOM      1   Si UNK A   1       2.710   2.710   0.000  1.00
+ATOM      2   Si UNK A   1       2.710   0.000   2.710  1.00
+ATOM      3   Si UNK A   1       0.000   2.710   2.710  1.00
+ATOM      4   Si UNK A   1       5.420   2.710   2.710  1.00
+ATOM      5   Si UNK A   1       2.710   5.420   2.710  1.00
+ATOM      6   Si UNK A   1       2.710   2.710   5.420  1.00
+ATOM      7   Si UNK A   1       5.420   5.420   5.420  1.00
+ATOM      8   Si UNK A   1       1.355   1.355   1.355  1.00
+TER       9      UNK A   1
+</pdb>
+                </molecule>
+                <parallelpiped>
+                    <origin>0.0 0.0 0.0</origin>
+                    <scale>5.42</scale>
+                    <vector id="1">.5 .5 .0</vector>
+                    <vector id="2">.5 .0 .5</vector>
+                    <vector id="3">.0 .5 .5</vector>
+                </parallelpiped>
+            </components>
+        </structure>
+        <time>Tue Nov 16 17:02:30 EST 2010</time>
+        <status>ok</status>
+        <user>gah</user>
+    </output>
+</run>
+
Index: branches/blt4/examples/zoo/parallelepiped/run1289945139214000.xml
===================================================================
--- branches/blt4/examples/zoo/parallelepiped/run1289945139214000.xml	(revision 1950)
+++ branches/blt4/examples/zoo/parallelepiped/run1289945139214000.xml	(revision 1950)
@@ -0,0 +1,81 @@
+<?xml version="1.0"?>
+<run>
+    <tool>
+        <about>Press Simulate to view results.</about>
+        <command>tclsh @tool/parallelpiped.tcl @driver</command>
+        <version>
+            <rappture>
+                <revision>$LastChangedRevision: 1719 $</revision>
+                <modified>$LastChangedDate: 2010-05-18 19:26:32 -0400 (Tue, 18 May 2010) $</modified>
+                <language>tcl</language>
+            </rappture>
+        </version>
+    </tool>
+    <input>
+        <number id="temperature">
+            <about>
+                <label>Ambient temperature</label>
+                <description>Temperature of the environment.</description>
+            </about>
+            <units>K</units>
+            <min>0K</min>
+            <max>500K</max>
+            <default>300K</default>
+            <preset>
+                <value>300K</value>
+                <label>300K (room temperature)</label>
+            </preset>
+            <preset>
+                <value>77K</value>
+                <label>77K (liquid nitrogen)</label>
+            </preset>
+            <preset>
+                <value>4.2K</value>
+                <label>4.2K (liquid helium)</label>
+            </preset>
+            <current>300K</current>
+        </number>
+        <number id="Ef">
+            <about>
+                <label>Fermi Level</label>
+                <description>Energy at center of distribution.</description>
+            </about>
+            <units>eV</units>
+            <min>-10eV</min>
+            <max>10eV</max>
+            <default>0eV</default>
+            <current>0eV</current>
+        </number>
+    </input>
+    <output>
+        <structure>
+            <components>
+                <molecule>
+                    <pdb>
+ATOM      0   Si UNK A   1       0.000   0.000   0.000  1.00
+ATOM      1   Si UNK A   1       2.710   2.710   0.000  1.00
+ATOM      2   Si UNK A   1       2.710   0.000   2.710  1.00
+ATOM      3   Si UNK A   1       0.000   2.710   2.710  1.00
+ATOM      4   Si UNK A   1       5.420   2.710   2.710  1.00
+ATOM      5   Si UNK A   1       2.710   5.420   2.710  1.00
+ATOM      6   Si UNK A   1       2.710   2.710   5.420  1.00
+ATOM      7   Si UNK A   1       5.420   5.420   5.420  1.00
+ATOM      8   Si UNK A   1       1.355   1.355   1.355  1.00
+TER       9      UNK A   1
+</pdb>
+                </molecule>
+                <parallelpiped>
+                    <origin>0.0 0.0 0.0</origin>
+                    <scale>5.42</scale>
+                    <vector id="1">.5 .5 .0</vector>
+                    <vector id="2">.5 .0 .5</vector>
+                    <vector id="3">.0 .5 .5</vector>
+                </parallelpiped>
+            </components>
+        </structure>
+        <time>Tue Nov 16 17:05:39 EST 2010</time>
+        <status>ok</status>
+        <user>gah</user>
+    </output>
+</run>
+
Index: branches/blt4/examples/zoo/parallelepiped/run1289945206317000.xml
===================================================================
--- branches/blt4/examples/zoo/parallelepiped/run1289945206317000.xml	(revision 1950)
+++ branches/blt4/examples/zoo/parallelepiped/run1289945206317000.xml	(revision 1950)
@@ -0,0 +1,81 @@
+<?xml version="1.0"?>
+<run>
+    <tool>
+        <about>Press Simulate to view results.</about>
+        <command>tclsh @tool/parallelpiped.tcl @driver</command>
+        <version>
+            <rappture>
+                <revision>$LastChangedRevision: 1719 $</revision>
+                <modified>$LastChangedDate: 2010-05-18 19:26:32 -0400 (Tue, 18 May 2010) $</modified>
+                <language>tcl</language>
+            </rappture>
+        </version>
+    </tool>
+    <input>
+        <number id="temperature">
+            <about>
+                <label>Ambient temperature</label>
+                <description>Temperature of the environment.</description>
+            </about>
+            <units>K</units>
+            <min>0K</min>
+            <max>500K</max>
+            <default>300K</default>
+            <preset>
+                <value>300K</value>
+                <label>300K (room temperature)</label>
+            </preset>
+            <preset>
+                <value>77K</value>
+                <label>77K (liquid nitrogen)</label>
+            </preset>
+            <preset>
+                <value>4.2K</value>
+                <label>4.2K (liquid helium)</label>
+            </preset>
+            <current>300K</current>
+        </number>
+        <number id="Ef">
+            <about>
+                <label>Fermi Level</label>
+                <description>Energy at center of distribution.</description>
+            </about>
+            <units>eV</units>
+            <min>-10eV</min>
+            <max>10eV</max>
+            <default>0eV</default>
+            <current>0eV</current>
+        </number>
+    </input>
+    <output>
+        <structure>
+            <components>
+                <molecule>
+                    <pdb>
+ATOM      0   Si UNK A   1       0.000   0.000   0.000  1.00
+ATOM      1   Si UNK A   1       2.710   2.710   0.000  1.00
+ATOM      2   Si UNK A   1       2.710   0.000   2.710  1.00
+ATOM      3   Si UNK A   1       0.000   2.710   2.710  1.00
+ATOM      4   Si UNK A   1       5.420   2.710   2.710  1.00
+ATOM      5   Si UNK A   1       2.710   5.420   2.710  1.00
+ATOM      6   Si UNK A   1       2.710   2.710   5.420  1.00
+ATOM      7   Si UNK A   1       5.420   5.420   5.420  1.00
+ATOM      8   Si UNK A   1       1.355   1.355   1.355  1.00
+TER       9      UNK A   1
+</pdb>
+                </molecule>
+                <parallelpiped>
+                    <origin>0.0 0.0 0.0</origin>
+                    <scale>5.42</scale>
+                    <vector id="1">.5 .5 .0</vector>
+                    <vector id="2">.5 .0 .5</vector>
+                    <vector id="3">.0 .5 .5</vector>
+                </parallelpiped>
+            </components>
+        </structure>
+        <time>Tue Nov 16 17:06:46 EST 2010</time>
+        <status>ok</status>
+        <user>gah</user>
+    </output>
+</run>
+
Index: branches/blt4/examples/zoo/parallelepiped/tool.xml
===================================================================
--- branches/blt4/examples/zoo/parallelepiped/tool.xml	(revision 1950)
+++ branches/blt4/examples/zoo/parallelepiped/tool.xml	(revision 1950)
@@ -0,0 +1,42 @@
+<?xml version="1.0"?>
+<run>
+    <tool>
+        <about>Press Simulate to view results.</about>
+        <command>tclsh @tool/parallelpiped.tcl @driver</command>
+    </tool>
+    <input>
+        <number id="temperature">
+            <about>
+                <label>Ambient temperature</label>
+                <description>Temperature of the environment.</description>
+            </about>
+            <units>K</units>
+            <min>0K</min>
+            <max>500K</max>
+            <default>300K</default>
+            <preset>
+                <value>300K</value>
+                <label>300K (room temperature)</label>
+            </preset>
+            <preset>
+                <value>77K</value>
+                <label>77K (liquid nitrogen)</label>
+            </preset>
+            <preset>
+                <value>4.2K</value>
+                <label>4.2K (liquid helium)</label>
+            </preset>
+        </number>
+        <number id="Ef">
+            <about>
+                <label>Fermi Level</label>
+                <description>Energy at center of distribution.</description>
+            </about>
+            <units>eV</units>
+            <min>-10eV</min>
+            <max>10eV</max>
+            <default>0eV</default>
+        </number>
+    </input>
+</run>
+